#! /usr/bin/python

from gi.repository import Gdk    
from gi.repository import Gtk
from gi.repository import Unity

from gi.repository import Dee
# FIXME: Some weird bug in Dee or PyGI makes Dee fail unless we probe
#        it *before* we import the Unity module... ?!
_m = dir(Dee.SequenceModel)

import hello_unity

class HelloLauncher(hello_unity.HelloUnitySection):

    def __init__(self):
        self.launcher = Unity.LauncherEntry.get_for_desktop_id("hello-unity.desktop")
        
    def get_controls(self):
        controls = Gtk.Table(3, 2, False)
        
        count_changer = Gtk.SpinButton()
        count_changer.set_increments(1, 1)
        count_changer.set_range(0, 999)
        count_changer.connect('value-changed', self.count_changed)

        controls.attach(Gtk.Label("Count"), 0, 1, 0, 1)
        controls.attach(count_changer, 1, 2, 0, 1, Gtk.AttachOptions.EXPAND | Gtk.AttachOptions.FILL)

        progress_changer = Gtk.Scale.new_with_range(Gtk.Orientation.HORIZONTAL, 0, 100, 1)
        progress_changer.connect('value-changed', self.progress_changed)

        controls.attach(Gtk.Label("Progress"), 0, 1, 1, 2)
        controls.attach(progress_changer, 1, 2, 1, 2, Gtk.AttachOptions.EXPAND | Gtk.AttachOptions.FILL)

        urgent_button = Gtk.ToggleButton("Make it Urgent")
        urgent_button.connect('toggled', self.made_urgent)
        
        controls.attach(Gtk.Label("Urgent"), 0, 1, 2, 3)
        controls.attach(urgent_button, 1, 2, 2, 3, Gtk.AttachOptions.EXPAND | Gtk.AttachOptions.FILL)
        return controls

    def made_urgent(self, button):
        self.launcher.set_property("urgent", button.get_active())
        
    def progress_changed(self, scale):
        value = scale.get_value()
        self.launcher.set_property("progress", value / 100)
        if value > 0:
            self.launcher.set_property("progress_visible", True)
        else:
            self.launcher.set_property("progress_visible", False)

    def count_changed(self, spinner):
        value = spinner.get_value()
        self.launcher.set_property("count", value)
        if value > 0:
            self.launcher.set_property("count_visible", True)
        else:
            self.launcher.set_property("count_visible", False)

    def get_code(self):
        '''
        Gets the code for this section to display in Hello Unity.

        In this case, it will  just read this file's contents
        '''
        
        codefilename = __file__
        if codefilename.endswith('.pyc'):
            codefilename = codefilename[:-1]
        codefile = open(codefilename)
        code = codefile.read()
        codefile.close()
        return code
