#! /usr/bin/python

from gi.repository import Gdk    
from gi.repository import Gtk

from gi.repository import Dee
# FIXME: Some weird bug in Dee or PyGI makes Dee fail unless we probe
#        it *before* we import the Unity module... ?!
_m = dir(Dee.SequenceModel)

from gi.repository import Notify

import hello_unity

class HelloNotifications(hello_unity.HelloUnitySection):

    def __init__(self):
        Notify.init('hello-unity')
        self.current_notification = None
    def get_controls(self):
        controls = Gtk.Table(6, 2, False)

        self.note_title = Gtk.Entry()
        self.note_title.set_text("Hello Unity")
        
        controls.attach(Gtk.Label("Title"), 0, 1, 0, 1)
        controls.attach(self.note_title, 1, 2, 0, 1, Gtk.AttachOptions.EXPAND | Gtk.AttachOptions.FILL)

        self.note_body = Gtk.Entry()
        self.note_body.set_text("Change this text to whatever you want it to be")
        
        controls.attach(Gtk.Label("Body"), 0, 1, 1, 2)
        controls.attach(self.note_body, 1, 2, 1, 2, Gtk.AttachOptions.EXPAND | Gtk.AttachOptions.FILL)

        self.note_icon = Gtk.Entry()
        self.note_icon.set_text(hello_unity.MONO_ICON_PATH)
        
        controls.attach(Gtk.Label("Icon"), 0, 1, 2, 3)
        controls.attach(self.note_icon, 1, 2, 2, 3, Gtk.AttachOptions.EXPAND | Gtk.AttachOptions.FILL)

        self.append_body = Gtk.CheckButton.new_with_label('Append New Messages')

        controls.attach(self.append_body, 1, 2, 3, 4, Gtk.AttachOptions.EXPAND | Gtk.AttachOptions.FILL)

        self.new_button = Gtk.Button("New Notification")
        self.new_button.connect('clicked', self.new_notification)
        
        controls.attach(self.new_button, 1, 2, 4, 5, Gtk.AttachOptions.EXPAND | Gtk.AttachOptions.FILL)

        self.update_button = Gtk.Button("Update Notification")
        self.update_button.connect('clicked', self.update_notification)
        self.update_button.set_sensitive(False)
        
        controls.attach(self.update_button, 1, 2, 5, 6, Gtk.AttachOptions.EXPAND | Gtk.AttachOptions.FILL)

        return controls

    def new_notification(self, button):
        self.current_notification = Notify.Notification.new(
            self.note_title.get_text(),
            self.note_body.get_text(),
            self.note_icon.get_text())
        if self.append_body.get_active():
            self.current_notification.set_hint_string('append', 'allowed')
        else:
            self.current_notification.clear_hints()
        self.current_notification.show ()
        self.update_button.set_sensitive(True)
        
    def update_notification(self, button):
        self.current_notification.update(
            self.note_title.get_text(),
            self.note_body.get_text(),
            self.note_icon.get_text())
        self.current_notification.show ()

    def get_code(self):
        '''
        Gets the code for this section to display in Hello Unity.

        In this case, it will  just read this file's contents
        '''
        
        codefilename = __file__
        if codefilename.endswith('.pyc'):
            codefilename = codefilename[:-1]
        codefile = open(codefilename)
        code = codefile.read()
        codefile.close()
        return code
